var instagraphWebSiteEndPoint = 'https://instawebapi.azurewebsites.net';
var instagraphWebApiEndPoint = instagraphWebSiteEndPoint + '/api';

var version = '4.0.5';
var minorRevision = '5';
var globalVersion = version + '.' + minorRevision;

var username;
var password;

var sessionId;

var deviceModel = widget.wrt.platform.model;

var platform = 'S60';

var clientKey = 'F4B9FA41-7F0A-4C19-854B-9C1E66915ADF';

var debugEnabled = false;

var cam;

var passwordAllowedChars = '1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM/|!$%&()=^[]@\xB0#,.-;:_<>+?`\'/*';
var usernameAllowedChars = '1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM_';

function bytesToSize(bytes) {
    var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
    if (bytes == 0) return 'n/a';
    var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
    return Math.round(bytes / Math.pow(1024, i), 2) + ' ' + sizes[[i]];
};

String.prototype.replaceAll = function( token, newToken, ignoreCase ) {
    var _token;
    var str = this + "";
    var i = -1;

    if ( typeof token === "string" ) {

        if ( ignoreCase ) {

            _token = token.toLowerCase();

            while( (
                i = str.toLowerCase().indexOf(
                    token, i >= 0 ? i + newToken.length : 0
                ) ) !== -1
            ) {
                str = str.substring( 0, i ) +
                    newToken +
                    str.substring( i + token.length );
            }

        } else {
            return this.split( token ).join( newToken );
        }

    }
return str;
};

function repeatString(str, num) {
    out = '';
    for (var i = 0; i < num; i++) {
        out += str; 
    }
    return out;
}

function dump(v, howDisplay, recursionLevel) {
    howDisplay = (typeof howDisplay === 'undefined') ? "alert" : howDisplay;
    recursionLevel = (typeof recursionLevel !== 'number') ? 0 : recursionLevel;


    var vType = typeof v;
    var out = vType;

    switch (vType) {
        case "number":
            /* there is absolutely no way in JS to distinguish 2 from 2.0
            so 'number' is the best that you can do. The following doesn't work:
            var er = /^[0-9]+$/;
            if (!isNaN(v) && v % 1 === 0 && er.test(3.0))
                out = 'int';*/
        case "boolean":
            out += ": " + v;
            break;
        case "string":
            out += "(" + v.length + '): "' + v + '"';
            break;
        case "object":
            //check if null
            if (v === null) {
                out = "null";

            }
            //If using jQuery: if ($.isArray(v))
            //If using IE: if (isArray(v))
            //this should work for all browsers according to the ECMAScript standard:
            else if (Object.prototype.toString.call(v) === '[object Array]') {  
                out = 'array(' + v.length + '): {\n';
                for (var i = 0; i < v.length; i++) {
                    out += repeatString('   ', recursionLevel) + "   [" + i + "]:  " + 
                        dump(v[i], "none", recursionLevel + 1) + "\n";
                }
                out += repeatString('   ', recursionLevel) + "}";
            }
            else { //if object    
                sContents = "{\n";
                cnt = 0;
                for (var member in v) {
                    //No way to know the original data type of member, since JS
                    //always converts it to a string and no other way to parse objects.
                    sContents += repeatString('   ', recursionLevel) + "   " + member +
                        ":  " + dump(v[member], "none", recursionLevel + 1) + "\n";
                    cnt++;
                }
                sContents += repeatString('   ', recursionLevel) + "}";
                out += "(" + cnt + "): " + sContents;
            }
            break;
    }

    if (howDisplay == 'body') {
        var pre = document.createElement('pre');
        pre.innerHTML = out;
        document.body.appendChild(pre)
    }
    else if (howDisplay == 'alert') {
        alert(out);
    }

    return out;
}

var debug = function(msg) {
	
	if(debugEnabled) {
		var currentdate = new Date();
		$('#debug').html($('#debug').html()
				+ currentdate.getDay() + "/" + currentdate.getMonth() + "/" + currentdate.getFullYear() + " "
				+ currentdate.getHours() + ":" + currentdate.getMinutes() + ":" + currentdate.getSeconds()
				+ ": " + msg + "<br />");
	}
};

// ErrorCallback function
function errorCB(err){
    alert("ErrorCode: " + err.code + " ErrorMessage: " + err.message);
}

var showPermissionError = function(msg) {
	$('#errDiv').html('<b style="color:#922;">ERROR</b>:<br />' + msg + '<br /><br /><div style="font-size:small;font-weight:normal;color:#999;padding:15px 0;">Please report error codes to support@venetasoft.it</div><br />').removeClass('hide');
	$('#main-wrapper').addClass('hide');
	$('#footer').addClass('hide');
	$('.loader').addClass('hide');
};

var showError = function(msg) {
	$('#errDiv').html('<b style="color:#922;">ERROR</b>:<br />' + msg + '<br /><br /><div style="font-size:small;font-weight:normal;color:#999;padding:15px 0;">Please report error codes to support@venetasoft.it</div><br /><br /><br /><button class="btn" onclick="$(\'#errDiv\').addClass(\'hide\');$(\'#main-wrapper\').removeClass(\'hide\');$(\'#footer\').removeClass(\'hide\');">Back</button>').removeClass('hide');
	$('#main-wrapper').addClass('hide');
	$('#footer').addClass('hide');
};

var showRegistrationError = function(msg) {
	$('#errDiv').html('<b style="color:#922;">ERROR</b>:<br />' + msg + '<br /><br /><div style="font-size:small;font-weight:normal;color:#999;padding:15px 0;">Please report error codes to support@venetasoft.it</div><br /><br /><br /><button class="btn" onclick="$(\'#errDiv\').addClass(\'hide\');$(\'#main-wrapper\').removeClass(\'hide\');$(\'#footer\').addClass(\'hide\');$(\'#account-back-link\').removeClass(\'hide\');">Back</button>').removeClass('hide');
	$('#main-wrapper').addClass('hide');
	$('#footer').addClass('hide');
}

var showUpdateError = function(msg) {
	$('#errDiv').html('<b style="color:#922;">ERROR</b>:<br />' + msg + '<br /><br />IF THIS IS A PIRATED COPY, PLEASE DO A CLEAN INSTALLATION FROM THE STORE, OR YOUR INSTAGRAM ACCOUNT WILL BE BLACKLISTED.<br /><br /><a class="btn" onclick="widget.openURL(\'http://store.ovi.com/content/388393\')">UPDATE APP FOR FREE</a>').removeClass('hide');
	$('#main-wrapper').addClass('hide');
	$('#footer').addClass('hide');
};


var ApiBridgeCheck = function() {
	try {
  	var apiBridgeFound = false;
  	var apiBridgeCheckError = null;
  	
  	var so = device.getServiceObject("Service.AppManager", "IAppManager");
  	
  	var criteria = new Object();
  	criteria.Type = 'Application';
  	
  	var result = so.IAppManager.GetList(criteria);
  	if (result.ErrorCode == 0) {
  		var iterator = result.ReturnValue;
			
  		var application;
  		
  		while ((application = iterator.getNext()) != undefined) {
				
  			if (application.Uid == '0x20023710') {
  				apiBridgeFound = true;
  				
  				break;
  			}
  		}
  	}
  	else {
  		apiBridgeCheckError = result.ErrorMessage;
  	}
		
		if(apiBridgeCheckError != null)
		{
			alert("There was an error! " + apiBridgeCheckError);
		}
		else if(!apiBridgeFound)
		{
			if(confirm("APIBridge by Nokia plugin will be installed, please follow the instructions. When the installation completes, please exit and run Instagraph again. The Nokia plugin will require you grant some permissions at every App startup."))
			{
				widget.openURL('http://instawebapi.azurewebsites.net/Plugins/ApiBridge/APIBridge_v1_1.sis');
			}
		}
		else
		{
			widget.openApplication( 0x20023710, "" );
		}
		
  }
	catch(exception) {
		alert(exception);
	}
};


//for browser 7.3 onwards
function getPermissions(){	
			
	//check that device & getServicePermissions exist for backward comptibility	
	if(device && typeof device.getServicePermissions == "function"){
		try {
			device.getServicePermissions({
				"Service.AppManager":"IAppManager",
				"Service.ServiceRegistry":"IService",
				"Service.SysInfo":"ISysInfo",
				"Service.MediaManagement":"IDataSource"
			});
		} 
		catch (e) {
			return false;
		}
	}
	
	//continue by using old per service permission model
	return true;
}


var machineID;

var getMachineId = function() {
	
	try {
		var so = device.getServiceObject("Service.SysInfo", "ISysInfo");
		
		var criteria = new Object();
		criteria.Entity = "Device";
		criteria.Key = "MachineID";
		
		try {
			var result = so.ISysInfo.GetInfo(criteria);

			var errCode = result.ErrorCode;
			var msg = "";
			
			if (errCode) {
				msg = "Failed Error: " + errCode;
				if(result.ErrorMessage != undefined) {
					msg += "Error Message: " + result.ErrorMessage;
					alert(msg);
				}
			}
			else {
				machineID = result.ReturnValue.Status;
			}
		}
		catch (e) {
		  alert ("getSysInfo: " + e);
		}
		
	}catch(exception) {
		alert(exception);
	}
};


var navToUploadIndex = function() {
	$('.loader').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').addClass('hide');
	$('#menu-2').removeClass('hide');
	$('#menu-3').addClass('hide');
	$('#main-wrapper').removeClass('hide');
	$('.page').addClass('hide');
	$('#page-upload').removeClass('hide');
	$('#upload-index').removeClass('hide');
	$('#form-upload').addClass('hide');
	$('#errDiv').addClass('hide');
	$('#upload-gallery').addClass('hide');
	$('#slider').removeClass('slideRight').addClass('slideLeft');
	window.menu.setRightSoftkeyLabel('', null);
}

var navToProfilePage = function() {
	$('.loader').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').addClass('hide');
	$('#menu-2').addClass('hide');
	$('#menu-3').removeClass('hide');
	$('#main-wrapper').removeClass('hide');
	$('.page').addClass('hide');
	$('#page-profile').removeClass('hide');
	$('#errDiv').addClass('hide');
	$('#slider').removeClass('slideRight').addClass('slideLeft');
	window.menu.setRightSoftkeyLabel('', null);
}

var navToRegistrationPage = function() {
	$('.loader').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').removeClass('hide');
	$('#menu-2').addClass('hide');
	$('#menu-3').addClass('hide');
	$('#main-wrapper').removeClass('hide');
	$('.page').addClass('hide');
	$('#page-new-account').addClass('hide');
	$('#page-login').addClass('hide');
	$('#slider').removeClass('slideLeft').addClass('slideRight');
	$('#errDiv').addClass('hide');
	$('#lnk-about').addClass('hide');
	window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
}

var navToLoginPage = function() {
	$('.loader').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').removeClass('hide');
	$('#menu-2').addClass('hide');
	$('#menu-3').addClass('hide');
	$('#main-wrapper').removeClass('hide');
	$('.page').addClass('hide');
	$('#page-login').removeClass('hide');
	$('#slider').removeClass('slideRight').addClass('slideLeft');
	$('#errDiv').addClass('hide');
	$('#lnk-about').removeClass('hide');
	window.menu.setRightSoftkeyLabel('', null);
}

var navToRegistrationPage = function() {
	$('.loader').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').removeClass('hide');
	$('#menu-2').addClass('hide');
	$('#menu-3').addClass('hide');
	$('#main-wrapper').removeClass('hide');
	$('.page').addClass('hide');
	$('#page-login').removeClass('hide');
	$('#slider').removeClass('slideRight').addClass('slideLeft');
	$('#divErr')
	window.menu.setRightSoftkeyLabel('', null);
}

var uploadCompleted = false;

var initApp = function () {
	
	try {
		window.menu.setRightSoftkeyLabel('', null);
		
		if (device != null && device != undefined && !getPermissions()) {
			$('#initial-loading').addClass('hide');
			$('.loader').addClass('hide');
			$('#footer').addClass('hide');
			$('#main-wrapper').addClass('hide');
			showPermissionError("You have to grant all permissions in order to execute Instagraph!");
			return;
		}
		else {
			
			if (device != null && device != undefined) {
				ApiBridgeCheck();
				getMachineId();
			}
			else {
				machineID = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c){
					var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
					return v.toString(16);
				});
			}
			
			if (window.widget) {
				widget.setNavigationEnabled(true);
			}
			
			$('#footer').removeClass('hide');
			$('#main-wrapper').removeClass('hide');
			$('#footer').addClass('hide');
			$('#page-login').addClass('hide');
			$('#footer').removeClass('hide');
			$('#page-login').removeClass('hide');
			$('#slider').removeClass('slideLeft').addClass('slideRight');
			$('#slider').removeClass('slideRight').addClass('slideLeft');
			
			$('#initial-loading').addClass('hide');
			
			$('.app-version').html('v. ' + version + '.' + minorRevision);
			
			$('#form-registration').attr('action', instagraphWebSiteEndPoint + '/account/registration ');
			$('.fld-platform').val(platform);
			$('.fld-machineid').val(machineID);
			$('.fld-client-key').val(clientKey);
			
			var savedUsername = widget.preferenceForKey("username");
			var savedPassword = widget.preferenceForKey("password");
			
			/*
			savedUsername = "venetatest4";
			savedPassword = "qwerty";
			*/
			
			if (savedUsername != null) {
				$('#login-username').val(savedUsername);
				
				if (device == null || device == undefined) {
					machineID = savedUsername;
					$('.fld-machineid').val(machineID);
				}
			}
			if (savedPassword != null) 
				$('#login-password').val(savedPassword);
			
			if (savedUsername != null && savedPassword != null && savedUsername != "" && savedPassword != "") {
			
				$('#page-login').addClass('hide');
				$('#footer').addClass('hide');
				$('#login-loading').removeClass('hide');
				$('#lnk-about').addClass('hide');
				
				logOn();
			}
		
			$('#form-upload-submit').on('click', function(e){
				e.preventDefault();
				
				var valid = true;
				var error = "";
				
				var comment = $('#upload-comment').val();
				if ((comment.split("#").length - 1) > 30) {
					valid = false;
					error = "Tags must be less than 30";
				}
				if (comment.length > 300) {
					valid = false;
					error = "Comment length must be less than 300 characters";
				}
				
				if (device != null && device != undefined) {
					if (selectedGalleryImage == null || selectedGalleryImage == undefined || selectedGalleryImage == "") {
						valid = false;
						error = "Please choose a picture from your gallery";
					}
				}
				
				/*
				if ((device == null || device == undefined) && $('#upload-gallery-file').val() == "") {
					valid = false;
					error = "Please choose a picture from your gallery";
				}
				*/
				
				if (valid == false) {
					$('#upload-loading').addClass('hide');
					$('#footer').addClass('hide');
					$('#menu-2').removeClass('hide');
					$('#slider').removeClass('slideRight');
					$('#slider').addClass('slideLeft');
					$('#first-column #page-upload').removeClass('hide');
					showError(error);
				}
				else {
				
					if (device == null || device == undefined) {
						 $('#form-upload').submit();
					}
					else {
						var parameters = {
							"comment": $("#upload-comment").val(),
							"filter": $("#filter").val(),
							"username": username,
							"password": password,
							"version": globalVersion,
							"language": language,
							"sessionid": sessionId,
							"deviceModel": deviceModel,
							"deviceuid": machineID,
							"clientKey": clientKey,
							"platform": platform,
							"rotation": 0
						}
						
						APIBridge.fileUpload("image", selectedGalleryImage, instagraphWebSiteEndPoint + '/upload/picture', parameters, function(res){
							$('#upload-index').removeClass('hide');
							$('#upload-gallery').addClass('hide');
							$('#form-upload').addClass('hide');
							
							if (res.responseText == "\"ok\"") {
								$('#upload-loading').addClass('hide');
								$('#menu-2').addClass('hide');
								$('#menu-3').removeClass('hide');
								$('#first-column #page-upload').addClass('hide');
								$('#footer').addClass('hide');
								$('.loader').addClass('hide');
								$('#queue-loading').removeClass('hide');
								$('#queue-complete').addClass('hide');
								$('#queue-empty').addClass('hide');
								$('#page-queue').removeClass('hide');
								$('#page-profile').removeClass('hide');
								$('#slider').removeClass('slideLeft').addClass('slideRight');
								
								uploadCompleted = true;
								
								loadQueue();
							}
							else 
								showError(res.responseText);
						}, function(res){
							$('#upload-index').removeClass('hide');
							$('#upload-gallery').addClass('hide');
							$('#form-upload').addClass('hide');
							$('.loader').addClass('hide');
							alert("Upload error: " + res.Status);
						});
					}
				}
			});
		}
	}
	catch (exception) {
		alert("Error: " + exception)
	}
};


// add zero padding for get two digits output for integers < 10
function addZ(n){
	return n<10? '0'+n:''+n;
}

function getSessionId(username) {
	var key = 129;
	var str = username.toLowerCase();
	var length = str.length;
	
	var output = 0;
	
	for(var i = 0; i < length; i++) {
		var charCode = str.charCodeAt(i);
		var charCodeEncoded = charCode ^ key;
		output += charCodeEncoded;
	}
	
	/*
	output = output*2;
	output += 74;
	*/
	/*
	var date = new Date();
	var month = addZ(date.getMonth()+1);
	var day = addZ(date.getDate());
	
	var dateString = month+day;

	for(var i = 0; i < dateString.length; i++) {
		var charCode = dateString.charCodeAt(i);
		var charCodeEncoded = charCode ^ key;
		output += String.fromCharCode(charCodeEncoded);
	}
	*/
	
	return output;
}


var photoEditorCallback = function() {
	$('#file-browser-loading').removeClass('hide');
	$('#upload-index').addClass('hide');
	getMediaList();
};

var openEditor = function() {
	var so = device.getServiceObject("Service.AppManager", "IAppManager");
	
	var criteria = new Object();
	criteria.ApplicationID = "s60uid://0x20026f35";
	//criteria.ApplicationID = "s60uid://0x2002134f";
	
	so.IAppManager.LaunchApp(criteria, photoEditorCallback);
};




var logOn = function () {
	
	
	window.menu.setRightSoftkeyLabel('', null);

	username = $('#login-username').val();
	password = $('#login-password').val();

	// Validation
	var usrValid = true;
	var pswValid = true;
	
	var usrLength = username.length;
	for(var i = 0; i < usrLength; i++) {
		var chr = username.charAt(i);
		if(passwordAllowedChars.indexOf(chr) === -1)
			usrValid = false;
	}
	
	var pswLength = password.length;
	for(var i = 0; i < pswLength; i++) {
		var chr = password.charAt(i);
		if(passwordAllowedChars.indexOf(chr) === -1)
			pswValid = false;
	}
	
	if(usrLength == 0) {
		//restore previous layout before show error
		$('#login-loading').addClass('hide');
		$('#menu-1').removeClass('hide');
		$('#menu-2').addClass('hide');
		$('#slider').removeClass('slideRight');
		$('#slider').addClass('slideLeft');
		$('#first-column #page-upload').addClass('hide');
		$('#first-column #page-login').removeClass('hide');
		window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
		showError("Please insert your username");
	}else if(pswLength == 0) {
		//restore previous layout before show error
		$('#login-loading').addClass('hide');
		$('#menu-1').removeClass('hide');
		$('#menu-2').addClass('hide');
		$('#slider').removeClass('slideRight');
		$('#slider').addClass('slideLeft');
		$('#first-column #page-upload').addClass('hide');
		$('#first-column #page-login').removeClass('hide');
		window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
		showError("Please insert your password");
	}
	else if (usrValid == false) {
		//restore previous layout before show error
		$('#login-loading').addClass('hide');
		$('#menu-1').removeClass('hide');
		$('#menu-2').addClass('hide');
		$('#slider').removeClass('slideRight');
		$('#slider').addClass('slideLeft');
		$('#first-column #page-upload').addClass('hide');
		$('#first-column #page-login').removeClass('hide');
		window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
		showError("Username contains invalid characters");
	}
	else if (pswValid == false) {
		//restore previous layout before show error
		$('#login-loading').addClass('hide');
		$('#menu-1').removeClass('hide');
		$('#menu-2').addClass('hide');
		$('#slider').removeClass('slideRight');
		$('#slider').addClass('slideLeft');
		$('#first-column #page-upload').addClass('hide');
		$('#first-column #page-login').removeClass('hide');
		window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
		showError("Please change your password using plain English charset from https://instagram.com/accounts/password/reset");
	}
	else {
		
		$('#lnk-about').addClass('hide');
		
		// Calculate SessionId
		sessionId = getSessionId(username);
		
		debug("SessionID: " + sessionId);
			
		$.ajax({
			type: "POST",
			url: instagraphWebSiteEndPoint + "/account/login",
			dataType: 'json',
			data: {
				username: username,
				password: password,
				version: globalVersion,
				language: language,
				sessionid: sessionId,
				devicemodel: deviceModel,
				deviceuid : machineID,
				clientKey : clientKey,
				platform: platform
			},
			success: function(data){
				try {
				
					// Logon successfull!
					if (data == 'ok') {
						widget.setPreferenceForKey(username, 'username');
						widget.setPreferenceForKey(password, 'password');
						
						debug('Login successful');
						
						// Add actions to the upload forms
						$('#form-upload').attr('action', instagraphWebSiteEndPoint + '/upload');
						$('#form-change-picture').attr('action', instagraphWebSiteEndPoint + '/account/changepicture');
						
						if(device == null || device == undefined) {
							$('#upload-index').addClass('hide');
							$('#fld-gallery-file').removeClass('hide');
							$('#form-upload').removeClass('hide');
							$('#upload-image-preview').addClass('hide');
						}
						
						// Change UI to show current page: #page-upload
						$('#login-loading').addClass('hide');
						$('#footer').removeClass('hide');
						$('#menu-1').addClass('hide');
						$('#menu-2').removeClass('hide');
						$('#slider').removeClass('slideRight');
						$('#slider').addClass('slideLeft');
						$('#first-column #page-upload').removeClass('hide');
						$('#second-column .page').addClass('hide');
						$('#lnk-about').addClass('hide');
						
						// Set all form fields values
						$('.ig-username').val(username);
						$('#lbl-username').html(username);
						$('.ig-password').val(password);
						
						$('.fld-version').val(globalVersion);
						$('.fld-language').val(language);
						$('.fld-sessionid').val(sessionId);
						$('.fld-devicemodel').val(deviceModel);
						
						// Load profile page info
						loadProfile()
					} else if (data.indexOf('UPDATE_APP') != -1) {
						//restore previous layout before show error
						$('#login-loading').addClass('hide');
						$('#menu-1').removeClass('hide');
						$('#menu-2').addClass('hide');
						$('#slider').removeClass('slideRight');
						$('#slider').addClass('slideLeft');
						$('#first-column #page-upload').addClass('hide');
						$('#first-column #page-login').removeClass('hide');
						showUpdateError('This version is obsolete and no more supported, please click this link to update your app:')
					} else {
						//restore previous layout before show error
						$('#login-loading').addClass('hide');
						$('#menu-1').removeClass('hide');
						$('#menu-2').addClass('hide');
						$('#slider').removeClass('slideRight');
						$('#slider').addClass('slideLeft');
						$('#first-column #page-upload').addClass('hide');
						$('#first-column #page-login').removeClass('hide');
						showError(data);
					}
				} catch (e) {
					showError(e.message);
				}
			},
			error: function(jqXHR, error, errorThrown){
				//restore previous layout before show error
				$('#login-loading').addClass('hide');
				$('#menu-1').removeClass('hide');
				$('#menu-2').addClass('hide');
				$('#slider').removeClass('slideRight');
				$('#slider').addClass('slideLeft');
				$('#first-column #page-upload').addClass('hide');
				$('#first-column #page-login').removeClass('hide');
				showError(errorThrown);
			}
		});
	}
};


var mediaList;

function createFileList(iterator) {
	
	try {
		
		var gallery = $('#gallery-list');
		
		mediaList = new Array();
		
		iterator.reset();
		
		var item;
		var i = 0;
		while ((item = iterator.getNext()) != undefined) {
			
			mediaList[i] = {
				path: item.FileNameAndPath,
				size: bytesToSize(item.FileSize)
			}
			var classString = '';
			
			if(i == 0)
				classString = 'class="selected"';
			
			gallery.append('<li><a onclick="showThumbnail(\'' + i+ '\', this)" ' + classString + ' >' + item.FileName + '</a></li>');
			
			i++;
		}
		var thumbso = nokia.device.load("media");
		var media = mediaList[parseInt(0)];
	
		selectedGalleryImage = media.path;
		$('#preview-path').html(media.path);
	
		$('#preview-loader').removeClass('hide');
		$('#gallery-preview').addClass('hide');
		$('#btn-choose-preview').addClass('hide');
	
		//define thumbnail size   
			var thumb={
				uri: "file://" + media.path,
				size:{
					width: 120,
					height: 120
				}
			};
			
			var transactionId = thumbso.getThumbnail(showThumb, thumb, errorCB);
		
		$('#file-browser-loading').addClass('hide');
		$('#upload-gallery').removeClass('hide');
		
	}
	catch(e) {
		alert(e);
	}
}

function galleryCallback(transId, eventCode, result) {
	
	if(result.ErrorCode != 0) {
		alert("Error in creating file list:" + result.ErrorCode);
		
		$('#file-browser-loading').addClass('hide');
		$('#footer').removeClass('hide');
		$('#upload-gallery').addClass('hide');
		$('#upload-index').removeClass('hide');
		
		return;
	}
	
	
	
	createFileList(result.ReturnValue);
}


function getMediaList() {
	
	window.menu.setRightSoftkeyLabel('Back', navToUploadIndex);
	
	try {
		//Getting service object, for multimedia.
		multimediaServiceObject = device.getServiceObject("Service.MediaManagement", "IDataSource");
		
		//Setting file criteria.
		var mediaCriteria = new Object();
		mediaCriteria.Type = "FileInfo";
		mediaCriteria.Filter = new Object();
		mediaCriteria.Filter.FileType = "Image";
		mediaCriteria.Sort = new Object();
		mediaCriteria.Sort.Key = "FileDate";
		mediaCriteria.Sort.Order = "Descending";
		
		//Asynchronous function for fetching files.
		window.setTimeout(function() { multimediaServiceObject.IDataSource.GetList(mediaCriteria, galleryCallback); }, 250);
	
	} catch( exception ) {
		alert("initialize error: " + exception);
	}
};

var thumbso;
var camera_so;

function camera_takePicture_error_callback(err){
	alert("Error Code:" + err.code + " Error Message:" + err.message);
	$('#camera-loading').addClass('hide');
	$('#page-upload').removeClass('hide');
	$('#upload-index').removeClass('hide');
}

function camera_takePicture_callback(picture_array){
	try {
		
		//alert(dump(picture_array));
		
		if(picture_array.length != 1)
		{
			$('#camera-loading').addClass('hide');
			$('#page-upload').removeClass('hide');
			$('#upload-index').removeClass('hide');
			$('#footer').removeClass('hide');
		}
		
		//actually in case of success, the lenght of the array is 1, no more
		for (var i = 0; i < picture_array.length; i++) {
			
			thumbso = nokia.device.load("media");
			
			var image_uri = picture_array[i].uri;
			
			// strip file:/// and replace with file://
			image_uri = image_uri.substring(8, image_uri.length);
			
			selectedGalleryImage = image_uri.replaceAll("/", "\\");
			
			/*
			var imageWidth = picture_array[i].format.width;
			var imageHeight = picture_array[i].format.height;
			var imageFormat = imageWidth / imageHeight;
			
			if(imageWidth >= imageHeight)
			{
				imageHeight = 612;
				imageWidth = Math.round(612 * imageFormat);
			}
			else {
				imageWidth = 612;
				imageHeight = Math.round(612 / imageFormat);
			}
			*/
			
			/*
			APIBridge.resizeImg(
				selectedGalleryImage,
				imageWidth,
				imageHeight,
				false,
				function(src) {
					alert("image resized to " + imageWidth + "x" + imageHeight + ": " + src);
					selectedGalleryImage = src.replaceAll("/", "\\");
				},
				function(req) {
					alert("ERROR "+req.status);
				}
			);
			*/
			
			image_uri = "file://" + image_uri;
			
			//define thumbnail size
			var thumb = {
				uri: image_uri,
				size: {
					width: 120,
					height: 120
				}
			}
			
			var transactionId = thumbso.getThumbnail(showCameraThumb, thumb, errorCB);
		}
	}
	catch(exception) {
		alert(exception);
	}
}

/**
 * Takes a picture with a native camera application
 */
function camera_takePicture(){
	try {
		
		$('#camera-loading').removeClass('hide');
		$('#page-upload').addClass('hide');
		$('#footer').addClass('hide');
		
		camera_so = nokia.device.load("camera");
		
		//launch native camera application and retreive the captured image
		var transactionID = camera_so.startCamera(camera_takePicture_callback, camera_takePicture_error_callback);
		
	}catch (e) {
		alert(e);
	}
}

var selectedGalleryImage;

var showThumbnail = function(mediaIndex, item) {
	
	var thumbso = nokia.device.load("media");
	
	var media = mediaList[parseInt(mediaIndex)];
	
	selectedGalleryImage = media.path;
	
	$('#gallery-list a').removeClass('selected');
	$(item).addClass('selected');
	
	$('#preview-path').html(media.path);
	
	$('#preview-loader').removeClass('hide');
	$('#gallery-preview').addClass('hide');
	$('#gallery-preview-size').html(media.size);
	$('#btn-choose-preview').addClass('hide');
	
	//define thumbnail size   
		var thumb={
			uri: "file://" + media.path,
			size:{
				width: 120,
				height: 120
			}
		};
		
		var transactionId = thumbso.getThumbnail(showThumb, thumb, errorCB);
};

var showThumb = function(uri) {
	
	$('#preview-loader').addClass('hide');
	$('#gallery-preview').attr('src', uri).removeClass('hide');
	$('#btn-choose-preview').removeClass('hide');
	
	$('#upload-image').attr('src', uri);
	
};

var showCameraThumb = function(uri) {
	
	try {
	
	$('#camera-loading').addClass('hide');
	$('#page-upload').removeClass('hide');
	
	$('#upload-image').attr('src', uri);
	
	selectGalleryImage();
	
	} catch (e) {
		alert(e);
	}
};

var selectGalleryImage = function() {
	
	window.menu.setRightSoftkeyLabel('Back', navToUploadIndex);
	
	
	$('#upload-index').addClass('hide');
	$('#upload-gallery').addClass('hide');
	$('#form-upload').removeClass('hide');
}

var resetUpload = function() {
	
	
	window.menu.setRightSoftkeyLabel('', null);
	
	selectedGalleryImage = null;
	
	$('#upload-index').removeClass('hide');
	$('#form-upload').addClass('hide');
	$('#upload-gallery').addClass('hide');
	
}

var validateRegistration = function (regUsername, regPassword, regEmail, regName) {
		
	var valid = true;
	
	var usrLength = regUsername.length;
	if(usrLength == 0) {
		return "Please insert the Username";
	}
	if(usrLength < 6)
	{
		return "Username must contains at least 6 characters";
	}
	for(var i = 0; i < usrLength; i++) {
		var chr = regUsername.charAt(i);
		if(usernameAllowedChars.indexOf(chr) === -1)
			valid = false;
	}
	if(valid == false)
		return "Username contains invalid characters. Please use only plain english charset";
	
	
	var pswLength = regPassword.length;
	if(pswLength == 0) {
		return "Please insert a Password";
	}
	if(pswLength < 6)
	{
		return "Password must contains at least 6 characters";
	}
	for(var i = 0; i < pswLength; i++) {
		var chr = regPassword.charAt(i);
		if(passwordAllowedChars.indexOf(chr) === -1)
			valid = false;
	}
	if(valid == false)
		return "Password contains invalid characters. Please use only plain english charset";
	
	
	var emailLength = regEmail.length;
	if(emailLength == 0) {
		return "Please insert a valid Email address";
	}
	var atpos=regEmail.indexOf("@");
	var dotpos=regEmail.lastIndexOf(".");
	if (atpos<1 || dotpos<atpos+2 || dotpos+2>=regEmail.length)
	{
		valid = false;
	}
	if(valid == false)
		return "Email address is not valid";
	
	
	var nameLength = regName.length;
	if(nameLength == 0) {
		return "Please insert your Name";
	}
	
	return "ok";
};




var pcMediaList;
var selectedPcGalleryImage;

function pcCreateFileList(iterator) {
	
	try {
		
		var gallery = $('#pc-gallery-list');
		
		pcMediaList = new Array();
		
		iterator.reset();
		
		var item;
		var i = 0;
		while ((item = iterator.getNext()) != undefined) {
			
			pcMediaList[i] = {
				path: item.FileNameAndPath,
				size: bytesToSize(item.FileSize)
			}
			var classString = '';
			
			if(i == 0)
				classString = 'class="selected"';
			
			gallery.append('<li><a onclick="showPcThumbnail(\'' + i+ '\', this)" ' + classString + ' >' + item.FileName + '</a></li>');
			
			i++;
		}
		var thumbso = nokia.device.load("media");
		var media = pcMediaList[parseInt(0)];
	
		selectedPcGalleryImage = media.path;
	
		$('#pc-preview-loader').removeClass('hide');
		$('#pc-gallery-preview').addClass('hide');
		$('#btn-change-picture-upload').addClass('hide');
	
		//define thumbnail size   
			var thumb={
				uri: "file://" + media.path,
				size:{
					width: 120,
					height: 120
				}
			};
			
			var transactionId = thumbso.getThumbnail(showPcThumb, thumb, errorCB);
		
		$('#file-browser-loading').addClass('hide');
		$('#page-change-picture').removeClass('hide');
		
	}
	catch(e) {
		alert(e);
	}
}

function pcGalleryCallback(transId, eventCode, result) {
	
	if(result.ErrorCode != 0) {
		alert("Error in creating file list:" + result.ErrorCode);
		
		$('#file-browser-loading').addClass('hide');
		$('#page-change-picture').addClass('hide');
		
		return;
	}
	
	pcCreateFileList(result.ReturnValue);
}


function getPcMediaList() {
	
	try {
		
		$('#footer').addClass('hide');
		$('#page-change-picture').addClass('hide');
		$('#file-browser-loading').removeClass('hide');
		
		//Getting service object, for multimedia.
		multimediaServiceObject = device.getServiceObject("Service.MediaManagement", "IDataSource");
		
		//Setting file criteria.
		var mediaCriteria = new Object();
		mediaCriteria.Type = "FileInfo";
		mediaCriteria.Filter = new Object();
		mediaCriteria.Filter.FileType = "Image";
		mediaCriteria.Sort = new Object();
		mediaCriteria.Sort.Key = "FileDate";
		mediaCriteria.Sort.Order = "Descending";
		
		//Asynchronous function for fetching files.
		window.setTimeout(function() { multimediaServiceObject.IDataSource.GetList(mediaCriteria, pcGalleryCallback); }, 250);
		} catch( exception ) {
			alert("initialize error: " + exception);
		}
};

var showPcThumbnail = function(mediaIndex, item) {
	
	var thumbso = nokia.device.load("media");
	
	var media = pcMediaList[parseInt(mediaIndex)];
	
	selectedPcGalleryImage = media.path;
	
	$('#pc-gallery-list a').removeClass('selected');
	$(item).addClass('selected');
	
	$('#pc-preview-loader').removeClass('hide');
	$('#pc-gallery-preview').addClass('hide');
	$('#btn-change-picture-upload').addClass('hide');
	$('#gallery-preview-size').html(media.size);
	
	//define thumbnail size   
		var thumb={
			uri: "file://" + media.path,
			size:{
				width: 120,
				height: 120
			}
		};
		
		var transactionId = thumbso.getThumbnail(showPcThumb, thumb, errorCB);
};


var showPcThumb = function(uri) {
	
	$('#pc-preview-loader').addClass('hide');
	$('#pc-gallery-preview').attr('src', uri).removeClass('hide');
	$('#btn-change-picture-upload').removeClass('hide');
	
};

var uploadPcImage = function(){
	
	try {
		$('#page-change-picture').addClass('hide');
		$('#footer').addClass('hide');
		$('#upload-loading').removeClass('hide');
  	
  	var parameters = {
  		"username": username,
  		"password": password,
  		"version": globalVersion,
  		"language": language,
  		"sessionid": sessionId,
  		"deviceModel": deviceModel,
  		"deviceuid": machineID,
  		"clientKey": clientKey,
  		"platform": platform,
			"rotation":0
  	}
  	
  	APIBridge.fileUpload("image", selectedPcGalleryImage, instagraphWebSiteEndPoint + '/account/changepictureJson', parameters, function(res){
  		$('#page-change-picture').addClass('hide');
  		$('#footer').addClass('hide');
  		$('#upload-loading').addClass('hide');
  		
			
			if (res.responseText == "\"ok\"") {
		  	$('#menu-2').addClass('hide');
		  	$('#menu-3').removeClass('hide');
		  	
		  	$('#queue-loading').removeClass('hide');
		  	$('#queue-complete').addClass('hide');
		  	$('#queue-empty').addClass('hide');
		  	$('#page-queue').removeClass('hide');
		  	$('#page-profile').removeClass('hide');
		  	$('#slider').removeClass('slideLeft').addClass('slideRight');
		  	
		  	uploadCompleted = true;
		  	
		  	loadQueue();
		  }
			else {
				showError(res.responseText);
			}
  	}, function(res){
  		$('#upload-loading').addClass('hide');
  		$('#page-change-picture').removeClass('hide');
  		$('#footer').removeClass('hide');
  		alert("ERROR: " + res.Status);
  	});
  	
  }catch(exception) {
		alert("Error:" + exception);
	}
};

var showThumb = function(uri) {
	
	$('#preview-loader').addClass('hide');
	$('#gallery-preview').attr('src', uri).removeClass('hide');
	$('#btn-choose-preview').removeClass('hide');
	
	$('#upload-image').attr('src', uri);
	
};


var setChangePictureNavigation = function() {
	$('#footer').addClass('hide');
	window.menu.setRightSoftkeyLabel('Back', navToProfilePage);
	
	if (device == null || device == undefined) {
		$('#pc-gallery-container').addClass('hide');
		$('#form-change-picture').removeClass('hide');
	}
	else {
		getPcMediaList();
	}
}

var setRegistrationNavigation = function() {
	window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
}

var setAboutNavigation = function() {
	window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
}

var createAccount = function () {

	var regUsername = $('#reg-usr').val();
	var regPassword = $('#reg-pwd').val();
	var regEmail = $('#reg-email').val();
	var regName = $('#reg-name').val();
	
	var validationResponse = validateRegistration(regUsername, regPassword, regEmail, regName);
	if(validationResponse != "ok") {
		
		$('#account-loading').addClass('hide');
		$('#footer').addClass('hide');
		$('#menu-1').removeClass('hide');
		$('#slider').addClass('slideRight');
		$('#slider').removeClass('slideLeft');
		$('#second-column #page-new-account').removeClass('hide');
		$('#account-back-link').removeClass('hide');
		
		window.menu.setRightSoftkeyLabel('Back', navToRegistrationPage);
		showRegistrationError(validationResponse);
	}
	else {
	
		var regSessionId = getSessionId(regUsername);
		
		$.ajax({
			type: "POST",
			url: instagraphWebSiteEndPoint + "/account/registration",
			dataType: 'json',
			data: {
				username: regUsername,
				password: regPassword,
				email: regEmail,
				name: regName,
				version: globalVersion,
				language: language,
				sessionid: regSessionId,
				devicemodel: deviceModel,
				deviceuid : machineID,
				clientKey : clientKey,
				platform: platform
			},
			success: function (data) {
				try {
				
					// Account creation job successfully queued
					if (data == "ok") {
						$('#account-loading').addClass('hide');
						$('#second-column #page-new-account').addClass('hide');
						$('#second-column #page-account-ok').removeClass('hide');
						$('#footer').addClass('hide');
						$('#menu-1').removeClass('hide');
						$('#slider').addClass('slideRight');
						$('#slider').removeClass('slideLeft');
						window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
						$('#account-back-link').addClass('hide');
					}
					// Account already exist
					else 
						if (data == "ok_exist") {
							$('#account-loading').addClass('hide');
							$('#second-column #page-new-account').addClass('hide');
							$('#second-column #page-account-exist').removeClass('hide');
							$('#footer').addClass('hide');
							$('#menu-1').removeClass('hide');
							$('#slider').addClass('slideRight');
							$('#slider').removeClass('slideLeft');
								window.menu.setRightSoftkeyLabel('Back', navToLoginPage);
							$('#account-back-link').addClass('hide');
						}
						else 
							if (data.indexOf('UPDATE_APP') != -1) {
								//restore previous layout before show error
								$('#account-loading').addClass('hide');
								$('#footer').addClass('hide');
								$('#menu-1').removeClass('hide');
								$('#slider').addClass('slideRight');
								$('#slider').removeClass('slideLeft');
								$('#second-column #page-new-account').removeClass('hide');
								$('#account-back-link').removeClass('hide');
								window.menu.setRightSoftkeyLabel('Back', navToRegistrationPage);
								showUpdateError("This version is obsolete and no more supported, please click this link to update your app:");
							}
							else {
								//restore previous layout before show error
								$('#account-loading').addClass('hide');
								$('#footer').addClass('hide');
								$('#menu-1').removeClass('hide');
								$('#slider').addClass('slideRight');
								$('#slider').removeClass('slideLeft');
								$('#second-column #page-new-account').removeClass('hide');
								$('#account-back-link').removeClass('hide');
								window.menu.setRightSoftkeyLabel('Back', navToRegistrationPage);
								showError(data);
							}
				} 
				catch (e) {
					$('#account-loading').addClass('hide');
					$('#footer').addClass('hide');
					$('#menu-1').removeClass('hide');
					$('#slider').addClass('slideRight');
					$('#slider').removeClass('slideLeft');
					$('#second-column #page-new-account').removeClass('hide');
					$('#account-back-link').addClass('hide');
					window.menu.setRightSoftkeyLabel('Back', navToRegistrationPage);
					showError(e.message);
				}
			},
			error: function(jqXHR, error, errorThrown){
				//restore previous layout before show error
				$('#account-loading').addClass('hide');
				$('#footer').addClass('hide');
				$('#menu-1').removeClass('hide');
				$('#slider').addClass('slideRight');
				$('#slider').removeClass('slideLeft');
				$('#second-column #page-new-account').removeClass('hide');
				$('#account-back-link').addClass('hide');
				showError(errorThrown);
			}
		});
	}
};

function applyFilter(filterName) {
	
	// Change UI to show current page: #page-upload
	$('#loading').addClass('hide');
	$('#filter-loading').addClass('hide');
	$('#footer').removeClass('hide');
	$('#menu-1').addClass('hide');
	$('#menu-2').removeClass('hide');
	$('#slider').removeClass('slideRight');
	$('#slider').addClass('slideLeft');
	$('#first-column #page-upload').removeClass('hide');
	$('#second-column .page').addClass('hide');
	
	// Filter selection
	$('#filter').val(filterName);
	$('#selected-filter img').attr("src", $('#' + filterName + " img").attr("src"));
	
	// Show selected filter
	$('.filter-selector').addClass('hide');
	$('.selected-filter').removeClass('hide');
}

function resetFilter() {
	$('#filter').val("");
	$('.filter-selector').removeClass('hide');
	$('.selected-filter').addClass('hide');
	
	$galleryFile = $('#fld-gallery-file').clone();
	$cameraFile = $('#fld-camera-file').clone();
	
	$('#fld-gallery-file').remove();
	$('#fld-camera-file').remove();
	
	$('#fld-comment').before($galleryFile);
	$('#fld-comment').before($cameraFile);
}

function resetUploadForm() {
	resetFilter();
	$('#upload-gallery-file').val('');
	$('#upload-camera-file').val('');
	$('#upload-comment').val('');
}

function loadProfile() {
	$.ajax({
		url: instagraphWebApiEndPoint + '/userdata?username=' + username,
		dataType: 'json',
		async: false,
		crossDomain: false,
		success: function(data) {
			try {
				if(data.ProfilePicture != null)
					$('#profile-image').attr("src", data.ProfilePicture);
			}
			catch (e) {
				showError(e.message);
			}
		},
		error: function(jqXHR, textStatus, errorThrown) {
			var data = jQuery.parseJSON(jqXHR.responseText);
			showError(errorThrown + ": " + data.ExceptionMessage);
		}
	});
}

var jobStateEnum = {
	UNASSIGNED: "Unassigned",
	WORKING: "Working",
	DONE: "Done",
	ERROR: "Error",
	QUEUED: "queued"
};

function loadQueue() {
	
	
	var endpoint = instagraphWebApiEndPoint + "/jobs?username=" + username;
	
	$.ajax({
		url: endpoint,
		dataType: 'json',
		async: false,
		crossDomain: false,
		success: function(data, textStatus, jqXHR) {

			try {
				
				if(data.length > 0) {
					var queueHtml = "";
					
					if (uploadCompleted == true) {
						
	
						window.menu.setRightSoftkeyLabel('Back', navToUploadIndex);
						$('#upload-success-message').removeClass('hide');
						uploadCompleted = false;
					}
					else {
	
						window.menu.setRightSoftkeyLabel('Back', navToProfilePage);
						$('#upload-success-message').addClass('hide');
					}
					
					for(var i in data)
					{
						queueHtml += '<div class="queue-item" style="padding-top:4px;">&nbsp;<div class="inline" style="display:inline-block">';
						var imageData = data[i].ImageData;
						var imageSrc = "data:image/jpeg;base64," + imageData;
						queueHtml += '<img src="' + imageSrc + '" style="width:46px;height:46px;" />';
						queueHtml += '</div>';
						
						//queueHtml += data[i].Name;
						
						queueHtml += '<div class="inline" style="padding-left:5px;display:inline-block;margin-right:10px;">&nbsp;&nbsp;';
						if(data[i].Status == jobStateEnum.DONE) {
							queueHtml += "Published";
							queueHtml += '<img src="images/check.png" />';
						}
						else if(data[i].Status == jobStateEnum.ERROR) {
							queueHtml += '<span style="color:#d00"><b>Error:</b> ' + data[i].ErrorMessage + '</span>';
							queueHtml += '<img src="images/error.png" />';
						}
						else {
							queueHtml += data[i].Status;
							queueHtml += '<img src="images/pending.png" /><div style="display:inline-block;vertical-align:top;">' + data[i].RemainingTimeSec + '</div>';
						}
						
						queueHtml += '</div>';
						queueHtml + '</div>';
					}
					
					$('#page-queue .queue-list').html(queueHtml).css('height','250px');
					$('#queue-complete').removeClass('hide');
					$('#queue-empty').addClass('hide');
				}
				else {
					$('#queue-complete').addClass('hide');
					$('#queue-empty').removeClass('hide');
				}
				
				// Change UI to show current page: #page-queue
				$('#queue-loading').addClass('hide');
				$('#queue-back-link').removeClass('hide');
				$('#footer').addClass('hide');
				$('#slider').removeClass('slideLeft');
				$('#slider').addClass('slideRight');
				$('#second-column #page-queue').removeClass('hide');
				//$('#first-column .page').addClass('hide');
			}
			catch (e) {
				showError(e.message);
			}
		},
		error: function(jqXHR, textStatus, errorThrown) {
			
			var data = jQuery.parseJSON(jqXHR.responseText);
			showError(errorThrown + ": " + data.ExceptionMessage );
		}
	});
	
}


function clearQueue() {

	debug("clearQueue");
	var endpoint = instagraphWebApiEndPoint + "/jobs?username=" + username + "&sessionid=" + sessionId;
	
	$.ajax({
		url: endpoint,
		dataType: 'json',
		async: false,
		crossDomain: false,
		success: function(data) {
			try {
				if(data == "ok")
				{
					debug("loadQueue");
					loadQueue();
				}
				else {
					showError(data);
				}
			}
			catch (e) {
				showError(e.message);
			}

			$('#queue-clear-loading').addClass('hide');
			$('#queue-back-link').removeClass('hide');
			$('#footer').addClass('hide');
			$('#slider').removeClass('slideLeft');
			$('#slider').addClass('slideRight');
			$('#second-column #page-queue').removeClass('hide');
			
		},
		error: function(jqXHR, textStatus, errorThrown) {
			var data = jQuery.parseJSON(jqXHR.responseText);
			showError(errorThrown + ": " + data.ExceptionMessage );
		}
	});
};


function logOut() {
	widget.setPreferenceForKey(null, "username");
	widget.setPreferenceForKey(null, "password");
	
	$('#login-username').val('');
	$('#login-password').val('');
	
	$('#footer').removeClass('hide');
	$('#menu-1').removeClass('hide');
	$('#menu-2').addClass('hide');
	$('#menu-3').addClass('hide');
	$('#first-column #page-profile').addClass('hide');
	$('#first-column #page-login').removeClass('hide');
};